<!DOCTYPE html>

<html lang="en" data-content_root="../../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>scripts.get_list_of_publishers &#8212; NLP004  documentation</title>
    <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=4f649999" />
    <link rel="stylesheet" type="text/css" href="../../_static/alabaster.css?v=039e1c02" />
    <script src="../../_static/documentation_options.js?v=5929fcd5"></script>
    <script src="../../_static/doctools.js?v=888ff710"></script>
    <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
   
  <link rel="stylesheet" href="../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <h1>Source code for scripts.get_list_of_publishers</h1><div class="highlight"><pre>
<span></span><span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">sys</span>
<span class="kn">import</span> <span class="nn">pandas</span> <span class="k">as</span> <span class="nn">pd</span>
<span class="kn">import</span> <span class="nn">get_by_doi</span>

<div class="viewcode-block" id="main">
<a class="viewcode-back" href="../../scripts/get_list_of_publishers.html#scripts.get_list_of_publishers.main">[docs]</a>
<span class="k">def</span> <span class="nf">main</span><span class="p">(</span><span class="n">file_path</span><span class="p">,</span> <span class="n">out_dir</span><span class="p">,</span> <span class="n">verbose</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&#39;&#39;&#39;</span>
<span class="sd">    main function for get_list_of_publishers. Filters list of publishers, and gives ones, present in the fiven dataset.</span>

<span class="sd">    Arguments:</span>
<span class="sd">        file_path (str): path to csv file - dataset, with DOIs.</span>
<span class="sd">        out_dir (str): path to the dir where to save relevant publishers list.</span>
<span class="sd">        vebose (bool): Optional. Vebose. Defaults to False.</span>
<span class="sd">    </span>
<span class="sd">    Retunrs:</span>
<span class="sd">        str: path to the result csv file.</span>
<span class="sd">    &#39;&#39;&#39;</span>
    <span class="k">if</span> <span class="ow">not</span> <span class="n">verbose</span><span class="p">:</span> <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Getting Publishers...&#39;</span><span class="p">)</span>
    
    <span class="n">csvfile</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">read_csv</span><span class="p">(</span><span class="n">file_path</span><span class="p">,</span> <span class="n">delimiter</span><span class="o">=</span><span class="s1">&#39;;&#39;</span><span class="p">,</span> <span class="n">quotechar</span><span class="o">=</span><span class="s1">&#39;&quot;&#39;</span><span class="p">)</span>
    <span class="n">dois</span> <span class="o">=</span> <span class="n">csvfile</span><span class="p">[</span><span class="s1">&#39;doi&#39;</span><span class="p">]</span>

    <span class="n">prefix_dict</span> <span class="o">=</span> <span class="n">get_by_doi</span><span class="o">.</span><span class="n">get_doi_prefix_dict</span><span class="p">()</span>
    
    <span class="n">relevant_publishers</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">unknown_publishers</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">()</span>
    <span class="n">no_doi</span> <span class="o">=</span> <span class="mi">0</span>

    <span class="k">for</span> <span class="n">prefix</span><span class="p">,</span> <span class="n">publisher</span> <span class="ow">in</span> <span class="n">prefix_dict</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
        <span class="n">matches</span> <span class="o">=</span> <span class="n">dois</span><span class="o">.</span><span class="n">str</span><span class="o">.</span><span class="n">contains</span><span class="p">(</span><span class="sa">f</span><span class="s1">&#39;^</span><span class="si">{</span><span class="n">prefix</span><span class="si">}</span><span class="s1">/&#39;</span><span class="p">,</span> <span class="n">regex</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span><span class="o">.</span><span class="n">sum</span><span class="p">()</span>
        <span class="k">if</span> <span class="n">verbose</span><span class="p">:</span> <span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s1">&#39;📖 </span><span class="si">{</span><span class="w"> </span><span class="n">prefix</span><span class="w"> </span><span class="si">}</span><span class="s1"> ::: </span><span class="si">{</span><span class="n">publisher</span><span class="si">}</span><span class="s1"> ::: </span><span class="si">{</span><span class="n">matches</span><span class="si">}</span><span class="s1">&#39;</span><span class="p">)</span>

        <span class="k">if</span> <span class="n">matches</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
            <span class="n">relevant_publishers</span><span class="o">.</span><span class="n">append</span><span class="p">({</span><span class="s1">&#39;prefix&#39;</span><span class="p">:</span> <span class="n">prefix</span><span class="p">,</span> <span class="s1">&#39;publisher&#39;</span><span class="p">:</span> <span class="n">publisher</span><span class="p">,</span> <span class="s1">&#39;occurrences&#39;</span><span class="p">:</span> <span class="n">matches</span><span class="p">})</span>
    
    <span class="n">relevant_publishers</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">(</span><span class="n">relevant_publishers</span><span class="p">)</span>
    <span class="n">relevant_publishers</span><span class="o">.</span><span class="n">to_csv</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">out_dir</span><span class="p">,</span> <span class="s1">&#39;relevant_publishers.csv&#39;</span><span class="p">),</span> <span class="n">index</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>

    <span class="k">for</span> <span class="n">row</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">dois</span><span class="p">)):</span>
        <span class="n">doi</span> <span class="o">=</span> <span class="n">dois</span><span class="p">[</span><span class="n">row</span><span class="p">]</span>
        <span class="k">if</span> <span class="n">doi</span> <span class="o">!=</span> <span class="s1">&#39;&#39;</span> <span class="ow">and</span> <span class="nb">type</span><span class="p">(</span><span class="n">doi</span><span class="p">)</span> <span class="o">==</span> <span class="nb">str</span><span class="p">:</span>
            <span class="n">publisher</span> <span class="o">=</span> <span class="n">get_by_doi</span><span class="o">.</span><span class="n">get_publisher</span><span class="p">(</span><span class="n">doi</span><span class="p">,</span> <span class="n">prefix_dict</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">publisher</span> <span class="o">==</span> <span class="s1">&#39;NIL&#39;</span><span class="p">:</span>
                <span class="n">prefix</span> <span class="o">=</span> <span class="n">doi</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s2">&quot;/&quot;</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span>
                <span class="k">if</span> <span class="n">verbose</span><span class="p">:</span> <span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s1">&#39;</span><span class="si">{</span><span class="w"> </span><span class="n">prefix</span><span class="w"> </span><span class="si">}</span><span class="s1">&#39;</span><span class="p">)</span>
                <span class="n">unknown_publishers</span><span class="p">[</span><span class="n">prefix</span><span class="p">]</span> <span class="o">=</span> <span class="n">unknown_publishers</span><span class="p">[</span><span class="n">prefix</span><span class="p">]</span> <span class="o">+</span> <span class="mi">1</span> <span class="k">if</span> <span class="n">prefix</span> <span class="ow">in</span> <span class="n">unknown_publishers</span> <span class="k">else</span> <span class="mi">1</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">verbose</span><span class="p">:</span> <span class="nb">print</span><span class="p">(</span><span class="n">doi</span><span class="p">)</span>
            <span class="n">no_doi</span> <span class="o">+=</span> <span class="mi">1</span>
    

    <span class="n">unknown_publishers</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">(</span><span class="nb">list</span><span class="p">(</span><span class="n">unknown_publishers</span><span class="o">.</span><span class="n">items</span><span class="p">()),</span> <span class="n">columns</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;prefix&#39;</span><span class="p">,</span> <span class="s1">&#39;occurrences&#39;</span><span class="p">])</span>
    <span class="n">unknown_publishers</span><span class="o">.</span><span class="n">to_csv</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">out_dir</span><span class="p">,</span> <span class="s1">&#39;unknown_publishers.csv&#39;</span><span class="p">),</span> <span class="n">index</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>

    <span class="n">relevant_publishers</span> <span class="o">=</span> <span class="n">relevant_publishers</span><span class="p">[</span><span class="s1">&#39;occurrences&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">sum</span><span class="p">()</span>
    <span class="n">unknown_publishers</span> <span class="o">=</span> <span class="n">unknown_publishers</span><span class="p">[</span><span class="s1">&#39;occurrences&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">sum</span><span class="p">()</span>

    <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Total Data: &#39;</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">dois</span><span class="p">))</span>
    <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Publishers Known: &#39;</span><span class="p">,</span> <span class="n">relevant_publishers</span><span class="p">)</span>
    <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Publishers Unknown: &#39;</span><span class="p">,</span> <span class="n">unknown_publishers</span><span class="p">)</span>
    <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;DOIs unknown:&#39;</span><span class="p">,</span> <span class="n">no_doi</span><span class="p">)</span>
    <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Total Checked: &#39;</span><span class="p">,</span> <span class="n">relevant_publishers</span><span class="o">+</span><span class="n">unknown_publishers</span><span class="o">+</span><span class="n">no_doi</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">out_dir</span><span class="p">,</span> <span class="s1">&#39;relevant_publishers.csv&#39;</span><span class="p">)</span></div>


<span class="k">if</span> <span class="vm">__name__</span> <span class="o">==</span> <span class="s1">&#39;__main__&#39;</span><span class="p">:</span>
<span class="w">    </span><span class="sd">&#39;&#39;&#39;</span>
<span class="sd">    Gets list of publishers from the given dataset</span>
<span class="sd">    Requeres the dataset path.</span>
<span class="sd">    &#39;&#39;&#39;</span>

    <span class="n">file_path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="n">sys</span><span class="o">.</span><span class="n">argv</span><span class="p">[</span><span class="mi">1</span><span class="p">])</span>
    <span class="n">out_dir</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="n">sys</span><span class="o">.</span><span class="n">argv</span><span class="p">[</span><span class="mi">2</span><span class="p">])</span>
    <span class="n">verbose</span> <span class="o">=</span> <span class="kc">False</span>
    <span class="k">if</span> <span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">sys</span><span class="o">.</span><span class="n">argv</span><span class="p">)</span><span class="o">==</span><span class="mi">4</span> <span class="ow">and</span> <span class="n">sys</span><span class="o">.</span><span class="n">argv</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span><span class="o">==</span><span class="s1">&#39;-v&#39;</span><span class="p">):</span>
        <span class="n">verbose</span> <span class="o">=</span> <span class="kc">True</span>
    
    <span class="n">main</span><span class="p">(</span><span class="n">file_path</span><span class="p">,</span> <span class="n">out_dir</span><span class="p">,</span> <span class="n">verbose</span><span class="p">)</span>
    
    
</pre></div>

          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../index.html">NLP004</a></h1>








<h3>Navigation</h3>
<p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../modules.html">python</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../pipe.html">pipe</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../index.html">Documentation overview</a><ul>
  <li><a href="../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2023, Ughur Mammadzada.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 7.2.6</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.13</a>
      
    </div>

    

    
  </body>
</html>